<template>
  <div class="container-fluid h-100 p-0">
    <CertificateModal
      v-show="showCertificateModal"
      :athleteId="certificateAthleteId"
      @closeModal="toggleCertificateModal(-1)"
    />

    <VAModal
      v-show="showVAModal"
      :athleteId="vaAthleteId"
      @closeModal="toggleVAModal(-1)"
    />

    <div class="container-fluid h-100" id="main">
      <div class="row">
        <div class="col-12 col-md-4 border-bottom text-start">
          <h1>Athletes</h1>
        </div>
        <div class="col-12 col-md-8 text-start text-md-end mt-2">
          <SearchBar @search="setSearch" />
        </div>
      </div>
      <div class="row">
        <div class="col text-end">
          <button class="btn btn-warning" @click="filter = !filter">
            Filtrer
          </button>
          <button class="btn btn-secondary ms-2" @click="filter = !filter">
            Syncroniser
          </button>
        </div>
      </div>

      <div class="row border-top my-3" v-show="filter">
        <div class="col-12 col-md-2 text-start">
          <label class="fw-bold" for="selectCertificateStatus"
            >Status certificat:</label
          >
          <select
            class="form-select"
            id="selectCertificateStatus"
            aria-label="Default select example"
          >
            <option value="" disabled selected hidden></option>
            <option value="1">Valide</option>
            <option value="2">Rejeté</option>
            <option value="3">A valider</option>
            <option value="3">Abscent</option>
          </select>
        </div>
        <div class="col-12 col-md-2 text-start">
          <label for="selectVaStatus" class="fw-bold">Status VA:</label>
          <select
            class="form-select"
            id="selectVaStatus"
            aria-label="Default select example"
          >
            <option value="" disabled selected hidden></option>
            <option value="1">Valide</option>
            <option value="2">Rejeté</option>
            <option value="3">A valider</option>
            <option value="3">Pas nécéssaire</option>
            <option value="4">Abscent</option>
          </select>
        </div>
        <div class="col-12 col-md-2 text-start">
          <label for="" class="fw-bold">Status payement:</label>
          <select class="form-select" aria-label="Default select example">
            <option value="" disabled selected hidden></option>
            <option value="1">Valid</option>
            <option value="2">Partiel</option>
            <option value="3">A valider</option>
            <option value="3">Abscent</option>
          </select>
        </div>
        <div class="col-12 col-md-2 text-start">
          <label for="" class="fw-bold">Catgeorie:</label>
          <select
            class="form-select"
            v-model="team__category__id"
            aria-label="Default select example"
          >
            <option value="" disabled selected hidden></option>
            <option
              v-for="category in categories"
              :key="category.id"
              :value="category.id"
            >
              {{ category.label }}
            </option>
          </select>
        </div>
        <div class="col-12 col-md-2 text-start d-flex align-middle">
          <button class="btn btn-secondary m-3">Reset</button>
        </div>
      </div>

      <div class="row rounded bg-light my-3">
        <table class="table table-striped table-hover">
          <thead>
            <tr>
              <th scope="col">Athlète</th>
              <th scope="col">Equipe</th>
              <th scope="col">Course</th>
              <th scope="col">Certificat</th>
              <th scope="col">VA</th>
              <th scope="col">Payement</th>
            </tr>
          </thead>
          <tbody v-if="athletes.length > 0">
            <tr v-for="athlete in athletes" :key="athlete.id">
              <td>{{ athlete.first_name }} {{ athlete.last_name }}</td>
              <td>{{ athlete.team.name }}</td>
              <td>{{ athlete.team.category.label }}</td>
              <td>
                <span
                  v-if="athlete.certificate.status === 0"
                  class="badge rounded-pill bg-secondary"
                  >Abscent</span
                >
                <span
                  v-else-if="athlete.certificate.status === 3"
                  class="badge rounded-pill bg-warning"
                  @click="toggleCertificateModal(athlete.id)"
                  >A valider</span
                >
                <span
                  v-if="athlete.certificate.status === 2"
                  class="badge rounded-pill bg-danger"
                  @click="toggleCertificateModal(athlete.id)"
                  >Rejeté</span
                ><span
                  v-if="athlete.certificate.status === 1"
                  class="badge rounded-pill bg-success"
                  @click="toggleCertificateModal(athlete.id)"
                  >Validé</span
                >
              </td>
              <td>
                <div v-if="athlete.va">
                  <span
                    v-if="athlete.va.status === 3"
                    class="badge rounded-pill bg-warning"
                    @click="toggleVAModal(athlete.id)"
                    >A valider</span
                  >
                  <span
                    v-if="athlete.va.status === 2"
                    class="badge rounded-pill bg-danger"
                    @click="toggleVAModal(athlete.id)"
                    >Rejeté</span
                  ><span
                    v-if="athlete.va.status === 1"
                    class="badge rounded-pill bg-success"
                    @click="toggleVAModal(athlete.id)"
                    >Validé</span
                  >
                  <span
                    v-if="athlete.va.status === 0"
                    class="badge rounded-pill bg-secondary"
                    @click="toggleVAModal(athlete.id)"
                    >Abscent</span
                  >
                </div>
                <div v-else>-</div>
              </td>
              <td>
                <div v-if="athlete.payment">
                  <span
                    v-if="athlete.va.status === 3"
                    class="badge rounded-pill bg-warning"
                    @click="toggleVAModal(athlete.id)"
                    >A valider</span
                  >
                  <span
                    v-if="athlete.va.status === 2"
                    class="badge rounded-pill bg-danger"
                    @click="toggleVAModal(athlete.id)"
                    >Rejeté</span
                  ><span
                    v-if="athlete.va.status === 1"
                    class="badge rounded-pill bg-success"
                    @click="toggleVAModal(athlete.id)"
                    >Validé</span
                  >
                  <span
                    v-if="athlete.va.status === 0"
                    class="badge rounded-pill bg-secondary"
                    @click="toggleVAModal(athlete.id)"
                    >Abscent</span
                  >
                </div>
                <div v-else>
                  <span class="badge rounded-pill bg-secondary"
                    >Abscent ou non associé</span
                  >
                </div>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import SearchBar from "../components/searchBar/SearchBar.vue";
import CertificateModal from "../components/modals/certificateModal/CertificateModal.vue";
import VAModal from "../components/modals/vaModal/VAModal.vue";
import axios from "axios";

export interface Category {
  id: number;
  label: string;
}

export interface Team {
  id: number;
  name: string;
  category: Category;
}

export interface Certificate {
  id: number;
  status: number;
}

export interface VA {
  id: number;
  status: number;
}

export interface Payment {
  id: number;
  command_reference: string;
  paid: number;
  va: boolean;
}

export interface Athlete {
  id: number;
  first_name: string;
  last_name: string;
  team: Team;
  certificate: Certificate;
  va: VA;
  payment: Payment;
}

export default defineComponent({
  components: {
    SearchBar,
    CertificateModal,
    VAModal,
  },
  data() {
    return {
      search: null as unknown,
      filter: false,
      certificateStatus: null,
      vaStatus: null,
      paymentStatus: null,
      showCertificateModal: false,
      certificateAthleteId: 0,
      showVAModal: false,
      vaAthleteId: 0,
      showPaymentModal: false,
      paymentAthleteId: 0,
      athletes: [] as Athlete[],
      selectedAthlete: -1,
      categories: [] as Category[],
      team__category__id: null,
    };
  },
  methods: {
    resetFilters() {
      this.certificateStatus = null;
      this.vaStatus = null;
      this.paymentStatus = null;
    },
    setSearch(search: string) {
      this.search = search;
    },
    toggleCertificateModal(id: number) {
      if (id !== -1) {
        this.certificateAthleteId = id;
      }
      this.showCertificateModal = !this.showCertificateModal;
      this.relaodTable();
    },
    toggleVAModal(id: number) {
      if (id !== -1) {
        this.vaAthleteId = id;
      }
      this.showVAModal = !this.showVAModal;
      this.relaodTable();
    },
    togglePaymentModal() {
      this.showPaymentModal = !this.showPaymentModal;
      this.relaodTable();
    },
    relaodTable() {
      axios
        .get("athletes", {
          params: {
            search: this.search,
            team__category__id: this.team__category__id,
          },
        })
        .then((response) => (this.athletes = response.data.results));
    },
    relaodCategories() {
      axios
        .get("categories")
        .then((response) => (this.categories = response.data.results));
    },
  },
  watch: {
    search() {
      console.log(this.search);
      this.relaodTable();
    },
    team__category__id() {
      this.relaodTable();
    },
  },
  mounted() {
    this.relaodTable();
    this.relaodCategories();
  },
});
</script>

<style></style>
